package com.zhili.zkstationserver.dto;

import com.zhili.zkstationserver.util.BytesUtil;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang.ArrayUtils;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2023/1/16 15:04
 */
@Data
@NoArgsConstructor
public class ChargerState {
    //站内
    String stationCode;
    //充电机id
    Integer chargerId;
    //充电机编码
    String chargerCode;
    //枪号
    Integer gunNo;
    //需求电压
    Float demandVoltage;
    //需求电流
    Float demandCurrent;
    //直流充电电压
    Float chargeVoltage;
    //直流充电电流
    Float chargeCurrent;
    //充电机状态
    Integer chargerState;
    //本次累积充电电量
    Float curAccCapacity;
    //通信状态
    Integer chargerComm;
    //预估充满时间
    Integer estimateTime;
    //电池sn
    String sn;
    //电池soc
    Integer soc;
    //电池soh
    Integer soh;
    //电池包总电流
    Float current;
    //电池包总电压
    Float innerV;
    //电芯温度最大值
    Integer maxCellTemp;
    //电芯温度最小值
    Integer minCellTemp;
    //电芯温度平均值
    Integer avgCellTemp;
    //最高温度电芯编号
    Integer maxTCSC;
    //最低温度电芯编号
    Integer minTCSC;
    //最大温度csc内探针编号
    Integer maxTCSCProbe;
    //最小温度csc内探针编号
    Integer minTCSCProbe;
    //最大电压
    Float maxCellVoltage;
    //电压最大值csc编号
    Integer maxVCSC;
    //最大电压csc内单体编号
    Integer maxVSingle;
    //电压平均值
    Float avgCellVoltage;
    //最小电压
    Float minCellVoltage;
    //电压最小值csc编号
    Integer minVCSC;
    //电压最小值所在CSC内单体编号
    Integer minVSingle;
    //电池连接状态
    Boolean connected;
    //额定总容量
    Float ratedEnergy;

    public ChargerState(String stationCode, byte[] data){
        this.stationCode = stationCode;
        this.chargerId = BytesUtil.toIntWithLowerFirst(ArrayUtils.subarray(data,0,1));
        this.chargerCode = BytesUtil.parseString(ArrayUtils.subarray(data, 1,33));
        this.gunNo = BytesUtil.toIntWithLowerFirst(ArrayUtils.subarray(data,33,1));
        this.chargerState = BytesUtil.toIntWithLowerFirst(ArrayUtils.subarray(data, 42,43));
        this.soc = BytesUtil.toIntWithLowerFirst(ArrayUtils.subarray(data, 80,81));
    }
}
